// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'controllers','ngCordova']).run(function($ionicPlatform) {
	$ionicPlatform.ready(function() {
		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		if (window.cordova && window.cordova.plugins.Keyboard) {
			cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		}
		if (window.StatusBar) {
			/*StatusBar.styleDefault();*/
			StatusBar.hide();
		}
		
	});
}).config(function($stateProvider, $urlRouterProvider) {

	// Ionic uses AngularUI Router which uses the concept of states
	// Learn more here: https://github.com/angular-ui/ui-router
	// Set up the various states which the app can be in.
	// Each state's controller can be found in controllers.js

	$stateProvider.state('game', {
        url : '/game',
        templateUrl : 'templates/game.html',
        controller : 'gameCtrl'
    }).state('gameLevels', {
		url : '/gameLevels',
		templateUrl : 'templates/gameLevels.html',
		controller : 'gameLevelsCtrl'
	}).state('setting', {
		url : '/setting',
		templateUrl : 'templates/setting.html',
		controller : 'settingCtrl'
	}).state('instruction', {
		url : '/instruction',
		templateUrl : 'templates/instruction.html'
	}).state('players', {
		url : '/players',
		templateUrl : 'templates/players.html',
		controller : 'playersCtrl'
	}).state('gameTwo', {
		url : '/gameTwo',
		templateUrl : 'templates/gameTwo.html',
		controller : 'gameCtrl'
	}).state('main', {
		url : '/main',
		templateUrl : 'templates/main.html',
		controller : 'mainCtrl'
	});

	// if none of the above states are matched, use this as the fallback
	$urlRouterProvider.otherwise('/main');
});
