controllers = angular.module("controllers", []);

controllers.controller("playersCtrl", function($scope, $timeout, $rootScope, $location, $cordovaMedia, $ionicLoading, $cordovaDialogs) {

	$scope.playersInitialise = function() {
		if ($rootScope.isMusicStopped == true) {
			$rootScope.isMusicStopped = false;
			document.addEventListener("deviceready", function() {
				function ok(value) {
					$rootScope.status = value;
					if ($rootScope.status == true) {
						$rootScope.lla = window.plugins.LowLatencyAudio;
						// preload audio resource
						$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
						}, function(msg) {
							console.log('error: ' + msg);
						});
						$rootScope.lla.loop('music');
					}
				}

				function fail(error) {
					$rootScope.status = true;
					var prefs = plugins.appPreferences;
					prefs.store(function(value) {
					}, function(error) {
					}, 'sound', $rootScope.status);
					if ($rootScope.status == true) {
						$rootScope.lla = window.plugins.LowLatencyAudio;
						// preload audio resource
						$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
						}, function(msg) {
							console.log('error: ' + msg);
						});
						$rootScope.lla.loop('music');
					}
				}

				var prefs = plugins.appPreferences;
				prefs.fetch(ok, fail, 'sound');
			}, false);
		}

	}

	$scope.playersSetup = function(playersMode) {
		$rootScope.playersMode = playersMode;
		if ($rootScope.playersMode == "onePlayerGame") {
			$location.path("/gameLevels");
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			$rootScope.playerOneScore=0;
			$rootScope.playerTwoScore=0;
			$location.path("/gameTwo");
		}

	}
});

controllers.controller("gameLevelsCtrl", function($scope, $timeout, $rootScope, $location, $cordovaMedia, $ionicLoading, $cordovaDialogs) {
	$scope.gameLevelsInitialise = function() {
		if ($rootScope.isMusicStopped == true) {
			$rootScope.isMusicStopped = false;
			document.addEventListener("deviceready", function() {
				function ok(value) {
					$rootScope.status = value;
					if ($rootScope.status == true) {
						$rootScope.lla = window.plugins.LowLatencyAudio;
						// preload audio resource
						$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
						}, function(msg) {
							console.log('error: ' + msg);
						});
						$rootScope.lla.loop('music');
					}
				}

				function fail(error) {
					$rootScope.status = true;
					var prefs = plugins.appPreferences;
					prefs.store(function(value) {
					}, function(error) {
					}, 'sound', $rootScope.status);
					if ($rootScope.status == true) {
						$rootScope.lla = window.plugins.LowLatencyAudio;
						// preload audio resource
						$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
						}, function(msg) {
							console.log('error: ' + msg);
						});
						$rootScope.lla.loop('music');
					}
				}

				var prefs = plugins.appPreferences;
				prefs.fetch(ok, fail, 'sound');
			}, false);
		}

	}

	$scope.clearScore = function(mode) {

		if (mode == "easy") {
			$rootScope.easyUserScore = 0;
			$rootScope.easyGameScore = 0;
		}
		if (mode == "medium") {
			$rootScope.mediumUserScore = 0;
			$rootScope.mediumGameScore = 0;
		}
		if (mode == "hard") {
			$rootScope.hardUserScore = 0;
			$rootScope.hardGameScore = 0;
		}
	}
	$scope.setup = function(mode) {
		$rootScope.mode = mode;
		//alert("$rootScope.mode: "+$rootScope.mode+"mode: "+mode);
		$rootScope.isModeEasy = false;
		$rootScope.isModeMedium = false;
		$rootScope.isModeHard = false;

		if ($rootScope.mode == "easy") {
			$rootScope.isModeEasy = true;
		}
		if ($rootScope.mode == "medium") {
			$rootScope.isModeMedium = true;
		}
		if ($rootScope.mode == "hard") {
			$rootScope.isModeHard = true;
		}
		$location.path("/game");
	}
});

controllers.controller("mainCtrl", function($scope, $rootScope, $cordovaDialogs, $ionicPlatform, $location, $ionicHistory) {
	$ionicPlatform.registerBackButtonAction(function(event) {
		if ($location.path() === "/main") {
			$cordovaDialogs.confirm('Really want to quit the game ?', 'Quit', ['OK', 'Cancel']).then(function(buttonIndex) {
				// no button = 0, 'OK' = 1, 'Cancel' = 2
				var btnIndex = buttonIndex;
				if (btnIndex == 1) {
					if ($rootScope.status == true) {
						document.addEventListener("deviceready", function() {
							$rootScope.lla.stop('music');
							$rootScope.lla.unload('music');
						}, false);
						ionic.Platform.exitApp();
					} else if ($rootScope.status == false) {
						ionic.Platform.exitApp();
					}
				}
			});
		} else {
			$ionicHistory.goBack();
		}
	}, 100);
	$rootScope.isMusicStopped = false;

	function playBackgroundMusic() {
		if ($rootScope.status == true && $rootScope.isMusicPlaying != true) {
			$rootScope.isMusicPlaying = true;
			$rootScope.lla = window.plugins.LowLatencyAudio;
			// preload audio resource
			$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
			}, function(msg) {
				console.log('error: ' + msg);
			});
			$rootScope.lla.loop('music');
		}
	}


	document.addEventListener("deviceready", function() {

		function ok(value) {
			$rootScope.status = value;
			playBackgroundMusic();
		}

		function fail(error) {
			$rootScope.status = true;
			var prefs = plugins.appPreferences;
			prefs.store(function(value) {
			}, function(error) {
			}, 'sound', $rootScope.status);
			playBackgroundMusic();
		}

		var prefs = plugins.appPreferences;
		prefs.fetch(ok, fail, 'sound');

		prefs.fetch(function(value) {
			$rootScope.easyUserScore = value;
		}, function() {
			$rootScope.easyUserScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'easyUserScore', $rootScope.easyUserScore);
		}, 'easyUserScore');

		prefs.fetch(function(value) {
			$rootScope.easyGameScore = value;
		}, function() {
			$rootScope.easyGameScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'easyGameScore', $rootScope.easyGameScore);
		}, 'easyGameScore');

		prefs.fetch(function(value) {
			$rootScope.mediumUserScore = value;
		}, function() {
			$rootScope.mediumUserScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'mediumUserScore', $rootScope.mediumUserScore);
		}, 'mediumUserScore');

		prefs.fetch(function(value) {
			$rootScope.mediumGameScore = value;
		}, function() {
			$rootScope.mediumGameScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'mediumGameScore', $rootScope.mediumGameScore);
		}, 'mediumGameScore');

		prefs.fetch(function(value) {
			$rootScope.hardUserScore = value;
		}, function() {
			$rootScope.hardUserScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'hardUserScore', $rootScope.hardUserScore);
		}, 'hardUserScore');

		prefs.fetch(function(value) {
			$rootScope.hardGameScore = value;
		}, function() {
			$rootScope.hardGameScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'hardGameScore', $rootScope.hardGameScore);
		}, 'hardGameScore');

		prefs.fetch(function(value) {
			$rootScope.playerOneScore = value;
		}, function() {
			$rootScope.playerOneScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'playerOneScore', $rootScope.playerOneScore);
		}, 'playerOneScore');

		prefs.fetch(function(value) {
			$rootScope.playerTwoScore = value;
		}, function() {
			$rootScope.playerTwoScore = 0;
			prefs.store(function(value) {
			}, function(error) {
			}, 'playerTwoScore', $rootScope.playerTwoScore);
		}, 'playerTwoScore');

	}, false);

	$scope.quit = function() {
		$cordovaDialogs.confirm('Really want to quit the game ?', 'Quit', ['OK', 'Cancel']).then(function(buttonIndex) {
			// no button = 0, 'OK' = 1, 'Cancel' = 2
			var btnIndex = buttonIndex;
			if (btnIndex == 1) {
				if ($rootScope.status == true) {
					document.addEventListener("deviceready", function() {
						$rootScope.lla.stop('music');
						$rootScope.lla.unload('music');
					}, false);
					ionic.Platform.exitApp();
				} else if ($rootScope.status == false) {
					ionic.Platform.exitApp();
				}

			}
		});

	}
});

controllers.controller("settingCtrl", function($scope, $rootScope) {
	document.addEventListener("deviceready", function() {
		function ok(value) {
			$rootScope.status = value;
		}

		function fail(error) {
			$rootScope.status = true;
			var prefs = plugins.appPreferences;
			prefs.store(function(value) {
			}, function(error) {
			}, 'sound', $rootScope.status);
		}

		var prefs = plugins.appPreferences;
		prefs.fetch(ok, fail, 'sound');
	}, false);
	$scope.setSettings = function(status) {
		$rootScope.status = status;

		document.addEventListener("deviceready", function() {
			var prefs = plugins.appPreferences;
			prefs.store(function(value) {
			}, function(error) {
			}, 'sound', $rootScope.status);

		}, false);

		if ($rootScope.status == true) {
			document.addEventListener("deviceready", function() {
				$rootScope.lla = window.plugins.LowLatencyAudio;
				// preload audio resource
				$rootScope.lla.preloadAudio('music', 'audio/music.mp3', 1, 1, function(msg) {
				}, function(msg) {
					console.log('error: ' + msg);
				});
				$rootScope.lla.loop('music');
			}, false);
		} else if ($rootScope.status == false) {
			document.addEventListener("deviceready", function() {

				$rootScope.lla.stop('music');
				$rootScope.lla.unload('music');

			}, false);
		}

	}
});

controllers.controller("gameCtrl", function($scope, $timeout, $rootScope, $cordovaMedia, $cordovaDialogs, $location, $interval) {

	$scope.playAgain = function() {
		if ($rootScope.playersMode == "onePlayerGame") {
			$location.path("/gameLevels");
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			$location.path("/players");
		}

	}

	$scope.initialize = function() {
		document.addEventListener("deviceready", function() {
			var prefs = plugins.appPreferences;

			if ($rootScope.playersMode == "onePlayerGame") {
				if ($rootScope.mode == "easy") {
					prefs.fetch(function(value) {
						$rootScope.easyUserScore = value;
					}, function() {
					}, 'easyUserScore');

					prefs.fetch(function(value) {
						$rootScope.easyGameScore = value;
					}, function() {
					}, 'easyGameScore');
				}
				if ($rootScope.mode == "medium") {
					prefs.fetch(function(value) {
						$rootScope.mediumUserScore = value;
					}, function() {
					}, 'mediumUserScore');

					prefs.fetch(function(value) {
						$rootScope.mediumGameScore = value;
					}, function() {
					}, 'mediumGameScore');
				}
				if ($rootScope.mode == "hard") {
					prefs.fetch(function(value) {
						$rootScope.hardUserScore = value;
					}, function() {
					}, 'hardUserScore');

					prefs.fetch(function(value) {
						$rootScope.hardGameScore = value;
					}, function() {
					}, 'hardGameScore');
				}

			} else if ($rootScope.playersMode == "twoPlayerGame") {

				$rootScope.playerOneScore = 0;
				$rootScope.playerTwoScore = 0;
				
				/*
				prefs.fetch(function(value) {
									$rootScope.playerOneScore = value;
								}, function() {
								}, 'playerOneScore');
				
								prefs.fetch(function(value) {
									$rootScope.playerTwoScore = value;
								}, function() {
								}, 'playerTwoScore');*/
				

			}

		}, false);

		$scope.winner = false;
		$scope.loser = false;
		$scope.noResult = false;
		$scope.checkmateWinner = false;
		$scope.checkmateLoser = false;

		$rootScope.isMusicStopped = false;

		$scope.media = null;

		$scope.gridclass = [];
		$scope.class1 = [];
		$scope.class2 = [];

		$scope.src = '/android_asset/www/audio/bass.mp3';
		$scope.winSound = '/android_asset/www/audio/winSound.mp3';
		$scope.lostSound = '/android_asset/www/audio/lostSound.mp3';

		$scope.grid = [[1, 2, 3, 4, 5, 6], [7, 8, 9, 10, 12, 14], [15, 16, 18, 20, 21, 24], [25, 27, 28, 30, 32, 35], [36, 40, 42, 45, 48, 49], [54, 56, 63, 64, 72, 81]];
		$scope.gridStatus = [[0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0]];
		$scope.disabled1 = [false, false, false, false, false, false, false, false, false];
		$scope.disabled2 = [false, false, false, false, false, false, false, false, false];
		$scope.numbers1 = [1, 2, 3, 4, 5, 6, 7, 8, 9];
		$scope.numbers2 = [1, 2, 3, 4, 5, 6, 7, 8, 9];

		for (var i = 0; i < $scope.gridclass.length; i++) {
			$scope.gridclass[i] = '' + $scope.cell1;
		}
		for (var i = 0; i < $scope.class1.length; i++) {
			$scope.class1[i] = '' + $scope.cell;
		}
		for (var i = 0; i < $scope.class2.length; i++) {
			$scope.class1[i] = '' + $scope.cell;
		}

	}
	function resetButtons1() {
		$scope.numbers1 = [1, 2, 3, 4, 5, 6, 7, 8, 9];
		$scope.disabled1 = [false, false, false, false, false, false, false, false, false];
	}

	function resetButtons2() {
		$scope.numbers2 = [1, 2, 3, 4, 5, 6, 7, 8, 9];
		$scope.disabled2 = [false, false, false, false, false, false, false, false, false];
	}

	function adjustButtons() {
		console.log("In adjustButtons");
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] != 0 && $scope.grid[i][j] % $scope.number1 == 0 && $scope.grid[i][j] / $scope.number1 <= 9) {
					console.log("2: " + $scope.grid[i][j] / $scope.number1);
					$scope.disabled2[($scope.grid[i][j] / $scope.number1) - 1] = true;
					$scope.numbers2[($scope.grid[i][j] / $scope.number1) - 1] = 'X';
				}
				if ($scope.gridStatus[i][j] != 0 && $scope.grid[i][j] % $scope.number2 == 0 && $scope.grid[i][j] / $scope.number2 <= 9) {
					console.log("1: " + $scope.grid[i][j] / $scope.number2);
					$scope.disabled1[($scope.grid[i][j] / $scope.number2) - 1] = true;
					$scope.numbers1[($scope.grid[i][j] / $scope.number2) - 1] = 'X';
				}
			}
		}
	}


	$scope.isDisabled1 = function(number) {
		var tempProduct = number * $scope.number2;
		console.log("number:" + number + "and $scope.number2:" + $scope.number2 + "and Product:" + tempProduct);
		for (var i = 0; i < 6; i++) {
			for ( j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] != 0 && tempProduct == $scope.grid[i][j]) {
					return true;
				} else {
					return false;
				}
			}
		}
	}
	$scope.setUp = function(userPlayCSS, computerPlayCSS, numberCSS, winUserCSS, cell, cell1, userNumberCSS, computerNumberCSS, winUserCSS1, winComputerCSS, winComputerCSS1) {

		$scope.initialize();

		$scope.count = 0;
		$scope.userPlayCSS = userPlayCSS;
		$scope.computerPlayCSS = computerPlayCSS;
		$scope.numberCSS = numberCSS;
		$scope.winUserCSS = winUserCSS;
		$scope.cell = cell;
		$scope.cell1 = cell1;
		$scope.userNumberCSS = userNumberCSS;
		$scope.computerNumberCSS = computerNumberCSS;
		$scope.winUserCSS1 = winUserCSS1;
		$scope.winComputerCSS = winComputerCSS;
		$scope.winComputerCSS1 = winComputerCSS1;

		$scope.number1 = 0;
		$scope.product = 0;
		$scope.lastMove = 0;
		$scope.isWin = false;
		$scope.number2 = randomIntFromInterval(1, 9);
		console.log($scope.number2);
		$scope.class2[$scope.number2 - 1] = ' ' + $scope.computerNumberCSS;
		$scope.disabled2[$scope.number2 - 1] = true;
		for (var i = 0; i < 9; i++) {
			$scope.disabled2[i] = true;
			if (i != ($scope.number2 - 1)) {
				$scope.numbers2[i] = 'X';

			} else {

			}
		}
	}

	$scope.onClick1 = function(i) {
		$scope.count++;
		$scope.isPlayed = 0;
		$scope.number1 = i + 1;
		resetButtons1();
		resetButtons2();
		$scope.disabled1[i] = true;

		$scope.disabled2[$scope.number2 - 1] = true;
		adjustButtons();
		$scope.class1 = [];
		$scope.class2[$scope.number2 - 1] = ' ' + $scope.numberCSS;

		if ($rootScope.playersMode == "onePlayerGame") {
			$scope.class1[i] = ' ' + $scope.userNumberCSS;
			$scope.availableChoices = [];
			$scope.availableChoicesCount = 0;
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			if ($scope.count % 2 != 0) {
				$scope.class1[i] = ' ' + $scope.userNumberCSS;
			} else {
				$scope.class1[i] = ' ' + $scope.computerNumberCSS;
			}
		}

		document.addEventListener("deviceready", function() {
			function ok(value) {
				$rootScope.status = value;
				if ($rootScope.status == true) {
					if ($scope.media != null) {
						$scope.media.release();
					}
					$scope.media = $cordovaMedia.newMedia($scope.src);
					$scope.media.play();
				}
			}

			function fail(error) {
				$rootScope.status = true;
				var prefs = plugins.appPreferences;
				prefs.store(function(value) {
				}, function(error) {
				}, 'sound', $rootScope.status);
				if ($rootScope.status == true) {
					if ($scope.media != null) {
						$scope.media.release();
					}
					$scope.media = $cordovaMedia.newMedia($scope.src);
					$scope.media.play();
				}
			}

			var prefs = plugins.appPreferences;
			prefs.fetch(ok, fail, 'sound');
		}, false);

		$scope.lastMove = $scope.number1;
		$scope.rowNumber = "  ( Row 1 )"

		//Update Score
		if ($rootScope.playersMode == "onePlayerGame") {
			if ($rootScope.mode == "easy") {
				$rootScope.easyUserScore = $rootScope.easyUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.easyUserScore = $rootScope.easyUserScore + 5;

					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "medium") {
				$rootScope.mediumUserScore = $rootScope.mediumUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.mediumUserScore = $rootScope.mediumUserScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "hard") {
				$rootScope.hardUserScore = $rootScope.hardUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.hardUserScore = $rootScope.hardUserScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}

		} else if ($rootScope.playersMode == "twoPlayerGame") {

			if ($scope.count % 2 != 0) {
				$rootScope.playerOneScore = $rootScope.playerOneScore + 1;
			} else {
				$rootScope.playerTwoScore = $rootScope.playerTwoScore + 1;
			}

			var tempCount1 = 0;
			var tempCount2 = 0;
			for (var i = 0; i < 10; i++) {
				if ($scope.numbers1[i] == 'X') {
					tempCount1 = tempCount1 + 1;
				}
				if ($scope.numbers2[i] == 'X') {
					tempCount2 = tempCount2 + 1;
				}
			}
			$scope.noOne = tempCount1;
			$scope.noTwo = tempCount2;
			if (tempCount1 == 8 && tempCount2 == 8) {

				if ($scope.count % 2 != 0) {

					$scope.checkmateWinner = true;
					$rootScope.playerOneScore = $rootScope.playerOneScore + 5;
				} else {

					$scope.checkmateLoser = true;
					$rootScope.playerTwoScore = $rootScope.playerTwoScore + 5;
				}

				$scope.isWin = true;

				document.addEventListener("deviceready", function() {
					var prefs = plugins.appPreferences;

					prefs.store(function(value) {
					}, function(error) {
					}, 'playerOneScore', $rootScope.playerOneScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'playerTwoScore', $rootScope.playerTwoScore);

				}, false);
			}
		}

		modifyGrid();
	}

	$scope.onClick2 = function(i) {
		$scope.count++;
		$scope.isPlayed = 0;
		resetButtons2();
		resetButtons1();
		$scope.disabled2[i] = true;
		$scope.disabled1[$scope.number1 - 1] = true;
		$scope.number2 = i + 1;
		adjustButtons();
		$scope.class2 = [];

		$scope.class1[$scope.number1 - 1] = ' ' + $scope.numberCSS;

		if ($rootScope.playersMode == "onePlayerGame") {
			$scope.class2[i] = ' ' + $scope.userNumberCSS;
			$scope.availableChoices = [];
			$scope.availableChoicesCount = 0;
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			if ($scope.count % 2 != 0) {
				$scope.class2[i] = ' ' + $scope.userNumberCSS;
			} else {
				$scope.class2[i] = ' ' + $scope.computerNumberCSS;
			}
		}

		document.addEventListener("deviceready", function() {
			function ok(value) {
				$rootScope.status = value;
				if ($rootScope.status == true) {
					if ($scope.media != null) {
						$scope.media.release();
					}
					$scope.media = $cordovaMedia.newMedia($scope.src);
					$scope.media.play();
				}
			}

			function fail(error) {
				$rootScope.status = true;
				var prefs = plugins.appPreferences;
				prefs.store(function(value) {
				}, function(error) {
				}, 'sound', $rootScope.status);
				if ($rootScope.status == true) {
					if ($scope.media != null) {
						$scope.media.release();
					}
					$scope.media = $cordovaMedia.newMedia($scope.src);
					$scope.media.play();
				}
			}

			var prefs = plugins.appPreferences;
			prefs.fetch(ok, fail, 'sound');
		}, false);

		$scope.lastMove = $scope.number2;
		$scope.rowNumber = "  ( Row 2 )"

		if ($rootScope.playersMode == "onePlayerGame") {
			if ($rootScope.mode == "easy") {
				$rootScope.easyUserScore = $rootScope.easyUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.easyUserScore = $rootScope.easyUserScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "medium") {
				$rootScope.mediumUserScore = $rootScope.mediumUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.mediumUserScore = $rootScope.mediumUserScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "hard") {
				$rootScope.hardUserScore = $rootScope.hardUserScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateWinner = true;
					$scope.isWin = true;
					$rootScope.hardUserScore = $rootScope.hardUserScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			if ($scope.count % 2 != 0) {
				$rootScope.playerOneScore = $rootScope.playerOneScore + 1;
			} else {
				$rootScope.playerTwoScore = $rootScope.playerTwoScore + 1;
			}

			var tempCount1 = 0;
			var tempCount2 = 0;
			for (var i = 0; i < 10; i++) {
				if ($scope.numbers1[i] == 'X') {
					tempCount1 = tempCount1 + 1;
				}
				if ($scope.numbers2[i] == 'X') {
					tempCount2 = tempCount2 + 1;
				}
			}
			$scope.noOne = tempCount1;
			$scope.noTwo = tempCount2;
			if (tempCount1 == 8 && tempCount2 == 8) {

				if ($scope.count % 2 != 0) {

					$scope.checkmateWinner = true;
					$rootScope.playerOneScore = $rootScope.playerOneScore + 5;
				} else {

					$scope.checkmateLoser = true;
					$rootScope.playerTwoScore = $rootScope.playerTwoScore + 5;
				}

				$scope.isWin = true;

				document.addEventListener("deviceready", function() {
					var prefs = plugins.appPreferences;

					prefs.store(function(value) {
					}, function(error) {
					}, 'playerOneScore', $rootScope.playerOneScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'playerTwoScore', $rootScope.playerTwoScore);

				}, false);
			}
		}

		/*
		 $rootScope.userScore = $rootScope.userScore + 1;
		 var tempCount1 = 0;
		 var tempCount2 = 0;
		 for (var i = 0; i < 10; i++) {
		 if ($scope.numbers1[i] == 'X') {
		 tempCount1 = tempCount1 + 1;
		 }
		 if ($scope.numbers2[i] == 'X') {
		 tempCount2 = tempCount2 + 1;
		 }
		 }
		 $scope.noOne = tempCount1;
		 $scope.noTwo = tempCount2;
		 if (tempCount1 == 8 && tempCount2 == 8) {
		 $scope.checkmateWinner = true;
		 $scope.isWin = true;
		 $rootScope.userScore = $rootScope.userScore + 5;
		 }*/

		modifyGrid();
	}
	function modifyGrid() {
		$scope.product = $scope.number1 * $scope.number2;
		if ($rootScope.playersMode == "onePlayerGame") {
			$scope.gridclass[$scope.product] = ' ' + $scope.userPlayCSS;
		} else if ($rootScope.playersMode == "twoPlayerGame") {
			if ($scope.count % 2 != 0) {
				$scope.gridclass[$scope.product] = ' ' + $scope.userPlayCSS;
			} else {
				$scope.gridclass[$scope.product] = ' ' + $scope.computerPlayCSS;
			}
		}

		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.grid[i][j] == $scope.product) {

					if ($rootScope.playersMode == "onePlayerGame") {
						$scope.gridStatus[i][j] = 1;
					} else if ($rootScope.playersMode == "twoPlayerGame") {
						if ($scope.count % 2 != 0) {
							$scope.gridStatus[i][j] = 1;
						} else {
							$scope.gridStatus[i][j] = 2;
						}
					}

					//	$scope.count++;
					if ($scope.count > 36) {

						$scope.result = "No RESULT";
						$scope.isWin = true;
						$scope.noResult = true;

						document.addEventListener("deviceready", function() {
							var prefs = plugins.appPreferences;

							if ($rootScope.playersMode == "onePlayerGame") {

								prefs.store(function(value) {
								}, function(error) {
								}, 'easyUserScore', $rootScope.easyUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'easyGameScore', $rootScope.easyGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumUserScore', $rootScope.mediumUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumGameScore', $rootScope.mediumGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'hardUserScore', $rootScope.hardUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'hardGameScore', $rootScope.hardGameScore);

							} else if ($rootScope.playersMode == "twoPlayerGame") {
								prefs.store(function(value) {
								}, function(error) {
								}, 'playerOneScore', $rootScope.playerOneScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'playerTwoScore', $rootScope.playerTwoScore);
							}

						}, false);
					}
				}
			}
		}
		if ($rootScope.playersMode == "onePlayerGame") {
			if (isWin(1)) {
				if ($rootScope.status == true) {
					document.addEventListener("deviceready", function() {

						$rootScope.lla.stop('music');
						$rootScope.lla.unload('music');

					}, false);
				}

				$rootScope.isMusicStopped = true;
				$scope.result = "W I N N E R !!!";
				document.addEventListener("deviceready", function() {
					function ok(value) {
						$rootScope.status = value;
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.winSound);
							media.play();
						}
					}

					function fail(error) {
						$rootScope.status = true;
						var prefs = plugins.appPreferences;
						prefs.store(function(value) {
						}, function(error) {
						}, 'sound', $rootScope.status);
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.winSound);
							media.play();
						}
					}

					var prefs = plugins.appPreferences;
					prefs.fetch(ok, fail, 'sound');
				}, false);

				$scope.isWin = true;
				$scope.winner = true;
				$scope.loser = false;

				$scope.flagx = 1;

				if ($rootScope.mode == "easy") {
					$rootScope.easyUserScore = $rootScope.easyUserScore + 10;
				}
				if ($rootScope.mode == "medium") {
					$rootScope.mediumUserScore = $rootScope.mediumUserScore + 10;
				}
				if ($rootScope.mode == "hard") {
					$rootScope.hardUserScore = $rootScope.hardUserScore + 10;
				}

				document.addEventListener("deviceready", function() {
					var prefs = plugins.appPreferences;

					prefs.store(function(value) {
					}, function(error) {
					}, 'easyUserScore', $rootScope.easyUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'easyGameScore', $rootScope.easyGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumUserScore', $rootScope.mediumUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumGameScore', $rootScope.mediumGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'hardUserScore', $rootScope.hardUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'hardGameScore', $rootScope.hardGameScore);

				}, false);
				$interval(indicateUserWin, 500);
				/*
				 $cordovaDialogs.alert('Hurray! YOU WON !!!', 'Congratulations !!!', 'OK').then(function() {
				 // callback success
				 $location.path("/gameLevels");
				 });*/

			} else {
				$timeout(thinkAndPlay, 1000);
			}

		} else if ($rootScope.playersMode == "twoPlayerGame") {
			if ($scope.count % 2 != 0) {
				if (isWin(1)) {
					if ($rootScope.status == true) {
						document.addEventListener("deviceready", function() {

							$rootScope.lla.stop('music');
							$rootScope.lla.unload('music');

						}, false);
					}

					$rootScope.isMusicStopped = true;
					$scope.result = "Player One Won";
					document.addEventListener("deviceready", function() {
						function ok(value) {
							$rootScope.status = value;
							if ($rootScope.status == true) {
								var media = $cordovaMedia.newMedia($scope.winSound);
								media.play();
							}
						}

						function fail(error) {
							$rootScope.status = true;
							var prefs = plugins.appPreferences;
							prefs.store(function(value) {
							}, function(error) {
							}, 'sound', $rootScope.status);
							if ($rootScope.status == true) {
								var media = $cordovaMedia.newMedia($scope.winSound);
								media.play();
							}
						}

						var prefs = plugins.appPreferences;
						prefs.fetch(ok, fail, 'sound');
					}, false);

					$scope.isWin = true;
					$scope.winner = true;
					$scope.loser = false;

					$scope.flagx = 1;

					$rootScope.playerOneScore = $rootScope.playerOneScore + 10;

					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'playerOneScore', $rootScope.playerOneScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'playerTwoScore', $rootScope.playerTwoScore);

					}, false);
					$interval(indicateUserWin, 500);
					/*
					 $cordovaDialogs.alert('Hurray! YOU WON !!!', 'Congratulations !!!', 'OK').then(function() {
					 // callback success
					 $location.path("/gameLevels");
					 });*/

				}
			} else {
				if (isWin(2)) {
					if ($rootScope.status == true) {
						document.addEventListener("deviceready", function() {

							$rootScope.lla.stop('music');
							$rootScope.lla.unload('music');

						}, false);
					}

					$rootScope.isMusicStopped = true;
					$scope.result = "Player Two Won";
					document.addEventListener("deviceready", function() {
						function ok(value) {
							$rootScope.status = value;
							if ($rootScope.status == true) {
								var media = $cordovaMedia.newMedia($scope.winSound);
								media.play();
							}
						}

						function fail(error) {
							$rootScope.status = true;
							var prefs = plugins.appPreferences;
							prefs.store(function(value) {
							}, function(error) {
							}, 'sound', $rootScope.status);
							if ($rootScope.status == true) {
								var media = $cordovaMedia.newMedia($scope.winSound);
								media.play();
							}
						}

						var prefs = plugins.appPreferences;
						prefs.fetch(ok, fail, 'sound');
					}, false);

					$scope.isWin = true;
					$scope.winner = false;
					$scope.loser = true;

					$scope.flagx = 1;

					$rootScope.playerTwoScore = $rootScope.playerTwoScore + 10;

					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'playerOneScore', $rootScope.playerOneScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'playerTwoScore', $rootScope.playerTwoScore);

					}, false);
					$interval(indicateComputerWin, 500);
					/*
					 $cordovaDialogs.alert('Hurray! YOU WON !!!', 'Congratulations !!!', 'OK').then(function() {
					 // callback success
					 $location.path("/gameLevels");
					 });*/

				}

			}
		}

	}

	function randomIntFromInterval(min, max) {
		return Math.floor(Math.random() * (max - min + 1) + min);
	}

	function getIndexFromArrayIndices(i, j) {
		var index = (6 * i) + j;
		return index;
	}

	function storeAvailableChoices(i, j) {
		console.log("In storeAvailableChoices ");
		if ($scope.gridStatus[i][j] == 0) {//if place is available
			if ($scope.grid[i][j] % $scope.number1 == 0 && $scope.grid[i][j] <= ($scope.number1 * 9))//if available number is multiple of number1 or multiple of number2
			{
				$scope.availableChoices[$scope.availableChoicesCount++] = $scope.grid[i][j];
			}
			if ($scope.grid[i][j] % $scope.number2 == 0 && $scope.grid[i][j] <= ($scope.number2 * 9)) {//if available number is multiple of number1 or multiple of number2
				$scope.availableChoices[$scope.availableChoicesCount++] = $scope.grid[i][j];
			}
		}
	}

	function playRandomlyFromAvailableChoices() {
		console.log("In playRandomlyFromAvailableChoices " + $scope.availableChoices.length);
		var x = randomIntFromInterval(0, $scope.availableChoices.length - 1);
		console.log("x= " + x + " and $scope.availableChoices[x]=" + $scope.availableChoices[x]);
		if ($scope.availableChoices[x] % $scope.number1 == 0 && $scope.availableChoices[x] / $scope.number1 <= 9) {//if winning number is multiple of number1

			//find number 2
			$scope.number2 = $scope.availableChoices[x] / $scope.number1;

			//Apply Css
			$scope.class2 = [];
			document.addEventListener("deviceready", function() {
				function ok(value) {
					$rootScope.status = value;
					if ($rootScope.status == true) {
						if ($scope.media != null) {
							$scope.media.release();
						}
						$scope.media = $cordovaMedia.newMedia($scope.src);
						$scope.media.play();
					}
				}

				function fail(error) {
					$rootScope.status = true;
					var prefs = plugins.appPreferences;
					prefs.store(function(value) {
					}, function(error) {
					}, 'sound', $rootScope.status);
					if ($rootScope.status == true) {
						if ($scope.media != null) {
							$scope.media.release();
						}
						$scope.media = $cordovaMedia.newMedia($scope.src);
						$scope.media.play();
					}
				}

				var prefs = plugins.appPreferences;
				prefs.fetch(ok, fail, 'sound');
			}, false);
			$scope.class1[$scope.number1 - 1] = ' ' + $scope.numberCSS;
			$scope.class2[$scope.number2 - 1] = ' ' + $scope.computerNumberCSS;
			$scope.gridclass[$scope.availableChoices[x]] = ' ' + $scope.computerPlayCSS;

			resetButtons2();
			resetButtons1();
			adjustButtons();
			$scope.disabled2[$scope.number2 - 1] = true;
			$scope.disabled1[$scope.number1 - 1] = true;

			$scope.lastMove = $scope.number2;
			$scope.rowNumber = "  ( Row 2 )";
			$scope.product = $scope.number1 * $scope.number2;
			if ($rootScope.mode == "easy") {
				$rootScope.easyGameScore = $rootScope.easyGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.easyGameScore = $rootScope.easyGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "medium") {
				$rootScope.mediumGameScore = $rootScope.mediumGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.mediumGameScore = $rootScope.mediumGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "hard") {
				$rootScope.hardGameScore = $rootScope.hardGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.hardGameScore = $rootScope.hardGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}

			//Change Grid Status
			for (var i = 0; i < 6; i++) {
				for (var j = 0; j < 6; j++) {
					if ($scope.availableChoices[x] == $scope.grid[i][j]) {
						$scope.gridStatus[i][j] = 2;
						$scope.count++;
						if ($scope.count > 36) {
							$scope.result = "No RESULT";
							$scope.isWin = true;
							$scope.noResult = true;

							document.addEventListener("deviceready", function() {
								var prefs = plugins.appPreferences;

								prefs.store(function(value) {
								}, function(error) {
								}, 'easyUserScore', $rootScope.easyUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'easyGameScore', $rootScope.easyGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumUserScore', $rootScope.mediumUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumGameScore', $rootScope.mediumGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'hardUserScore', $rootScope.hardUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'hardGameScore', $rootScope.hardGameScore);

							}, false);
							/*
							 $cordovaDialogs.alert('No RESULT" !!!', 'Oops!', 'OK').then(function() {
							 // callback success
							 $location.path("/choice");
							 });*/

						}
					}
				}
			}
			$scope.isPlayed = 1;
			if (isWin(2)) {
				if ($rootScope.status == true) {
					document.addEventListener("deviceready", function() {
						$rootScope.lla.stop('music');
						$rootScope.lla.unload('music');

					}, false);
				}

				$rootScope.isMusicStopped = true;
				$scope.result = "L O S E R";
				document.addEventListener("deviceready", function() {
					function ok(value) {
						$rootScope.status = value;
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.lostSound);
							media.play();
						}
					}

					function fail(error) {
						$rootScope.status = true;
						var prefs = plugins.appPreferences;
						prefs.store(function(value) {
						}, function(error) {
						}, 'sound', $rootScope.status);
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.lostSound);
							media.play();
						}
					}

					var prefs = plugins.appPreferences;
					prefs.fetch(ok, fail, 'sound');
				}, false);
				$scope.isWin = true;
				$scope.loser = true;
				$scope.winner = false;
				$scope.flagx = 1;

				if ($rootScope.mode == "easy") {
					$rootScope.easyGameScore = $rootScope.easyGameScore + 10;
				}
				if ($rootScope.mode == "medium") {
					$rootScope.mediumGameScore = $rootScope.mediumGameScore + 10;
				}
				if ($rootScope.mode == "hard") {
					$rootScope.hardGameScore = $rootScope.hardGameScore + 10;
				}

				document.addEventListener("deviceready", function() {
					var prefs = plugins.appPreferences;

					prefs.store(function(value) {
					}, function(error) {
					}, 'easyUserScore', $rootScope.easyUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'easyGameScore', $rootScope.easyGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumUserScore', $rootScope.mediumUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumGameScore', $rootScope.mediumGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'hardUserScore', $rootScope.hardUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'hardGameScore', $rootScope.hardGameScore);

				}, false);
				$interval(indicateComputerWin, 500);
				/*
				 $cordovaDialogs.alert('YOU LOST !!!', 'Oops!', 'OK').then(function() {
				 // callback success
				 $location.path("/choice");
				 });*/

			}
		} else if ($scope.availableChoices[x] % $scope.number2 == 0 && $scope.availableChoices[x] / $scope.number2 <= 9) {//if winning number is multiple of number2
			console.log("In playtoForceUser-winning number is multiple of number2");
			//find number 1
			$scope.number1 = $scope.availableChoices[x] / $scope.number2;
			console.log("In playtoForceUser-new number1=" + $scope.number1);

			//Apply Css
			$scope.class1 = [];
			document.addEventListener("deviceready", function() {
				function ok(value) {
					$rootScope.status = value;
					if ($rootScope.status == true) {
						if ($scope.media != null) {
							$scope.media.release();
						}
						$scope.media = $cordovaMedia.newMedia($scope.src);
						$scope.media.play();
					}
				}

				function fail(error) {
					$rootScope.status = true;
					var prefs = plugins.appPreferences;
					prefs.store(function(value) {
					}, function(error) {
					}, 'sound', $rootScope.status);
					if ($rootScope.status == true) {
						if ($scope.media != null) {
							$scope.media.release();
						}
						$scope.media = $cordovaMedia.newMedia($scope.src);
						$scope.media.play();
					}
				}

				var prefs = plugins.appPreferences;
				prefs.fetch(ok, fail, 'sound');
			}, false);
			$scope.class2[$scope.number2 - 1] = ' ' + $scope.numberCSS;
			$scope.class1[$scope.number1 - 1] = ' ' + $scope.computerNumberCSS;
			$scope.gridclass[$scope.availableChoices[x]] = ' ' + $scope.computerPlayCSS;

			resetButtons1();
			resetButtons2();
			adjustButtons();
			$scope.disabled1[$scope.number1 - 1] = true;
			$scope.disabled2[$scope.number2 - 1] = true;

			$scope.lastMove = $scope.number1;
			$scope.rowNumber = "  ( Row 1 )";
			$scope.product = $scope.number1 * $scope.number2;
			if ($rootScope.mode == "easy") {
				$rootScope.easyGameScore = $rootScope.easyGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.easyGameScore = $rootScope.easyGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "medium") {
				$rootScope.mediumGameScore = $rootScope.mediumGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.mediumGameScore = $rootScope.mediumGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}
			if ($rootScope.mode == "hard") {
				$rootScope.hardGameScore = $rootScope.hardGameScore + 1;
				var tempCount1 = 0;
				var tempCount2 = 0;
				for (var i = 0; i < 10; i++) {
					if ($scope.numbers1[i] == 'X') {
						tempCount1 = tempCount1 + 1;
					}
					if ($scope.numbers2[i] == 'X') {
						tempCount2 = tempCount2 + 1;
					}
				}
				$scope.noOne = tempCount1;
				$scope.noTwo = tempCount2;
				if (tempCount1 == 8 && tempCount2 == 8) {
					$scope.checkmateLoser = true;
					$scope.isWin = true;
					$rootScope.hardGameScore = $rootScope.hardGameScore + 5;
					document.addEventListener("deviceready", function() {
						var prefs = plugins.appPreferences;

						prefs.store(function(value) {
						}, function(error) {
						}, 'easyUserScore', $rootScope.easyUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'easyGameScore', $rootScope.easyGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumUserScore', $rootScope.mediumUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'mediumGameScore', $rootScope.mediumGameScore);

						prefs.store(function(value) {
						}, function(error) {
						}, 'hardUserScore', $rootScope.hardUserScore);
						prefs.store(function(value) {
						}, function(error) {
						}, 'hardGameScore', $rootScope.hardGameScore);

					}, false);
				}
			}

			//Change Grid Status
			for (var i = 0; i < 6; i++) {
				for (var j = 0; j < 6; j++) {
					if ($scope.availableChoices[x] == $scope.grid[i][j]) {
						$scope.gridStatus[i][j] = 2;
						$scope.count++;
						if ($scope.count > 36) {
							$scope.result = "No RESULT";
							$scope.isWin = true;
							document.addEventListener("deviceready", function() {
								var prefs = plugins.appPreferences;

								prefs.store(function(value) {
								}, function(error) {
								}, 'easyUserScore', $rootScope.easyUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'easyGameScore', $rootScope.easyGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumUserScore', $rootScope.mediumUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'mediumGameScore', $rootScope.mediumGameScore);

								prefs.store(function(value) {
								}, function(error) {
								}, 'hardUserScore', $rootScope.hardUserScore);
								prefs.store(function(value) {
								}, function(error) {
								}, 'hardGameScore', $rootScope.hardGameScore);

							}, false);
						}
					}
				}
			}
			$scope.isPlayed = 1;
			if (isWin(2)) {
				if ($rootScope.status == true) {
					document.addEventListener("deviceready", function() {

						$rootScope.lla.stop('music');
						$rootScope.lla.unload('music');

					}, false);
				}

				$rootScope.isMusicStopped = true;
				$scope.result = "L O S E R";
				document.addEventListener("deviceready", function() {
					function ok(value) {
						$rootScope.status = value;
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.lostSound);
							media.play();
						}
					}

					function fail(error) {
						$rootScope.status = true;
						var prefs = plugins.appPreferences;
						prefs.store(function(value) {
						}, function(error) {
						}, 'sound', $rootScope.status);
						if ($rootScope.status == true) {
							var media = $cordovaMedia.newMedia($scope.lostSound);
							media.play();
						}
					}

					var prefs = plugins.appPreferences;
					prefs.fetch(ok, fail, 'sound');
				}, false);
				$scope.isWin = true;
				$scope.loser = true;
				$scope.winner = false;
				$scope.flagx = 1;
				if ($rootScope.mode == "easy") {
					$rootScope.easyGameScore = $rootScope.easyGameScore + 10;
				}
				if ($rootScope.mode == "medium") {
					$rootScope.mediumGameScore = $rootScope.mediumGameScore + 10;
				}
				if ($rootScope.mode == "hard") {
					$rootScope.hardGameScore = $rootScope.hardGameScore + 10;
				}
				document.addEventListener("deviceready", function() {
					var prefs = plugins.appPreferences;

					prefs.store(function(value) {
					}, function(error) {
					}, 'easyUserScore', $rootScope.easyUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'easyGameScore', $rootScope.easyGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumUserScore', $rootScope.mediumUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'mediumGameScore', $rootScope.mediumGameScore);

					prefs.store(function(value) {
					}, function(error) {
					}, 'hardUserScore', $rootScope.hardUserScore);
					prefs.store(function(value) {
					}, function(error) {
					}, 'hardGameScore', $rootScope.hardGameScore);

				}, false);
				$interval(indicateComputerWin, 500);
				/*
				 $cordovaDialogs.alert('Oops! YOU LOST !!!', 'Sorry!', 'OK').then(function() {
				 // callback success
				 $location.path("/choice");
				 });*/

			}
		}
	}

	function thinkAndPlay() {
		if ($rootScope.mode == "easy") {
			if ($scope.isPlayed == 0) {
				attemptForWin();
			}
			if ($scope.isPlayed == 0) {
				playRandom();
			}
		}
		if ($rootScope.mode == "medium") {
			if ($scope.isPlayed == 0) {
				attemptForWin();
			}
			if ($scope.isPlayed == 0) {
				forceUserToDefence();
			}
			if ($scope.isPlayed == 0) {
				playRandom();
			}
		}
		if ($rootScope.mode == "hard") {
			if ($scope.isPlayed == 0) {
				attemptForWin();
			}
			if ($scope.isPlayed == 0) {
				destroyUsersWin();
			}
			if ($scope.isPlayed == 0) {
				forceUserToDefence();
			}
			if ($scope.isPlayed == 0) {
				destroyUsersWinPlan();
			}
			if ($scope.isPlayed == 0) {
				playRandom();
			}
		}

	}

	function attemptForWin() {
		//Horizontal sets
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 4; j++) {
				if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i][j + 1] == 2 && $scope.gridStatus[i][j + 2] == 2) {
					if (j == 0) {
						storeAvailableChoices(i, j + 3);
					} else if (j == 3) {
						storeAvailableChoices(i, j - 1);
					} else {
						storeAvailableChoices(i, j + 3);
						storeAvailableChoices(i, j - 1);
					}
				}
			}
		}

		//Verticle sets
		for (var i = 0; i < 4; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j] == 2 && $scope.gridStatus[i+2][j] == 2) {
					if (i == 0) {
						storeAvailableChoices(i + 3, j);
					} else if (i == 3) {
						storeAvailableChoices(i - 1, j);
					} else {
						storeAvailableChoices(i + 3, j);
						storeAvailableChoices(i - 1, j);
					}
				}
			}
		}

		//Diagonal Sets
		for (var i = 0; i < 4; i++) {
			if ($scope.gridStatus[i][i] == 2 && $scope.gridStatus[i+1][i + 1] == 2 && $scope.gridStatus[i+2][i + 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, i + 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, i - 1);
				} else {
					storeAvailableChoices(i + 3, i + 3);
					storeAvailableChoices(i - 1, i - 1);
				}
			}
		}

		//Immidiate Upper Diagonal Sets
		for (var i = 0; i < 3; i++) {
			var j = i + 1;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2 && $scope.gridStatus[i+2][j + 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 3, j + 3);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Immidiate Lower Diagonal Sets
		for (var j = 0; j < 3; j++) {
			var i = j + 1;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2 && $scope.gridStatus[i+2][j + 2] == 2) {
				if (j == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (j == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 3, j + 3);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Upper Diagonal Set
		for (var i = 0; i < 2; i++) {
			var j = i + 2;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2 && $scope.gridStatus[i+2][j + 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (i == 1) {
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Lower Diagonal Set
		for (var j = 0; j < 2; j++) {
			var i = j + 2;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2 && $scope.gridStatus[i+2][j + 2] == 2) {
				if (j == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (j == 1) {
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Anti Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = 5 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2 && $scope.gridStatus[i+2][j - 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Upper Ant-Diagonal Sets
		for (var i = 0; i < 3; i++) {
			var j = 4 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2 && $scope.gridStatus[i+2][j - 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Lower Anti-Diagonal Sets
		for (var i = 1; i < 4; i++) {
			var j = 6 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2 && $scope.gridStatus[i+2][j - 2] == 2) {
				if (i == 1) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Upper Anti-Diagonal Set
		for (var i = 0; i < 2; i++) {
			var j = 3 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2 && $scope.gridStatus[i+2][j - 2] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 1) {
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Lower Anti-Diagonal Set
		for (var i = 2; i < 4; i++) {
			var j = 7 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2 && $scope.gridStatus[i+2][j - 2] == 2) {
				if (i == 2) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}
		playRandomlyFromAvailableChoices();
	}

	function destroyUsersWin() {
		//Horizontal sets
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 4; j++) {
				if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i][j + 1] == 1 && $scope.gridStatus[i][j + 2] == 1) {
					if (j == 0) {
						storeAvailableChoices(i, j + 3);
					} else if (j == 3) {
						storeAvailableChoices(i, j - 1);
					} else {
						storeAvailableChoices(i, j + 3);
						storeAvailableChoices(i, j - 1);
					}
				}
			}
		}

		//Verticle sets
		for (var i = 0; i < 4; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j] == 1 && $scope.gridStatus[i+2][j] == 1) {
					if (i == 0) {
						storeAvailableChoices(i + 3, j);
					} else if (i == 3) {
						storeAvailableChoices(i - 1, j);
					} else {
						storeAvailableChoices(i + 3, j);
						storeAvailableChoices(i - 1, j);
					}
				}
			}
		}

		//Diagonal Sets
		for (var i = 0; i < 4; i++) {
			if ($scope.gridStatus[i][i] == 1 && $scope.gridStatus[i+1][i + 1] == 1 && $scope.gridStatus[i+2][i + 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, i + 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, i - 1);
				} else {
					storeAvailableChoices(i + 3, i + 3);
					storeAvailableChoices(i - 1, i - 1);
				}
			}
		}

		//Immidiate Upper Diagonal Sets
		for (var i = 0; i < 3; i++) {
			var j = i + 1;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1 && $scope.gridStatus[i+2][j + 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 3, j + 3);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Immidiate Lower Diagonal Sets
		for (var j = 0; j < 3; j++) {
			var i = j + 1;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1 && $scope.gridStatus[i+2][j + 2] == 1) {
				if (j == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (j == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 3, j + 3);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Upper Diagonal Set
		for (var i = 0; i < 2; i++) {
			var j = i + 2;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1 && $scope.gridStatus[i+2][j + 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (i == 1) {
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Lower Diagonal Set
		for (var j = 0; j < 2; j++) {
			var i = j + 2;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1 && $scope.gridStatus[i+2][j + 2] == 1) {
				if (j == 0) {
					storeAvailableChoices(i + 3, j + 3);
				} else if (j == 1) {
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Anti Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = 5 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1 && $scope.gridStatus[i+2][j - 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Upper Ant-Diagonal Sets
		for (var i = 0; i < 3; i++) {
			var j = 4 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1 && $scope.gridStatus[i+2][j - 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Lower Anti-Diagonal Sets
		for (var i = 1; i < 4; i++) {
			var j = 6 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1 && $scope.gridStatus[i+2][j - 2] == 1) {
				if (i == 1) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 3, j - 3);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Upper Anti-Diagonal Set
		for (var i = 0; i < 2; i++) {
			var j = 3 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1 && $scope.gridStatus[i+2][j - 2] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 1) {
					console.log("i=" + i + " j=" + j);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Lower Anti-Diagonal Set
		for (var i = 2; i < 4; i++) {
			var j = 7 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1 && $scope.gridStatus[i+2][j - 2] == 1) {
				if (i == 2) {
					storeAvailableChoices(i + 3, j - 3);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}
		playRandomlyFromAvailableChoices();
	}

	function forceUserToDefence() {
		//Horizontal sets
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 5; j++) {
				if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i][j + 1] == 2) {
					if (j == 0) {
						storeAvailableChoices(i, j + 2);
					} else if (j == 4) {
						storeAvailableChoices(i, j - 1);
					} else {
						storeAvailableChoices(i, j + 2);
						storeAvailableChoices(i, j - 1);
					}
				}
			}
		}

		//Verticle sets
		for (var i = 0; i < 5; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j] == 2) {
					if (i == 0) {
						storeAvailableChoices(i + 2, j);
					} else if (i == 4) {
						storeAvailableChoices(i - 1, j);
					} else {
						storeAvailableChoices(i + 2, j);
						storeAvailableChoices(i - 1, j);
					}
				}
			}
		}

		//Diagonal Sets
		for (var i = 0; i < 5; i++) {
			if ($scope.gridStatus[i][i] == 2 && $scope.gridStatus[i+1][i + 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, i + 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, i - 1);
				} else {
					storeAvailableChoices(i + 2, i + 2);
					storeAvailableChoices(i - 1, i - 1);
				}
			}
		}

		//Immidiate Upper Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = i + 1;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Immidiate Lower Diagonal Sets
		for (var j = 0; j < 4; j++) {
			var i = j + 1;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2) {
				if (j == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (j == 3) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Upper Diagonal Set
		for (var i = 0; i < 3; i++) {
			var j = i + 2;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Lower Diagonal Set
		for (var j = 0; j < 3; j++) {
			var i = j + 2;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j + 1] == 2) {
				if (j == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (j == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Anti Diagonal Sets
		for (var i = 0; i < 5; i++) {
			var j = 5 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Upper Ant-Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = 4 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Lower Anti-Diagonal Sets
		for (var i = 1; i < 5; i++) {
			var j = 6 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2) {
				if (i == 1) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Upper Anti-Diagonal Set
		for (var i = 0; i < 3; i++) {
			var j = 3 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Lower Anti-Diagonal Set
		for (var i = 2; i < 5; i++) {
			var j = 7 - i;
			if ($scope.gridStatus[i][j] == 2 && $scope.gridStatus[i+1][j - 1] == 2) {
				if (i == 2) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}
	}

	function destroyUsersWinPlan() {
		//Horizontal sets
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 5; j++) {
				if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i][j + 1] == 1) {
					if (j == 0) {
						storeAvailableChoices(i, j + 2);
					} else if (j == 4) {
						storeAvailableChoices(i, j - 1);
					} else {
						storeAvailableChoices(i, j + 2);
						storeAvailableChoices(i, j - 1);
					}
				}
			}
		}

		//Verticle sets
		for (var i = 0; i < 5; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j] == 1) {
					if (i == 0) {
						storeAvailableChoices(i + 2, j);
					} else if (i == 4) {
						storeAvailableChoices(i - 1, j);
					} else {
						storeAvailableChoices(i + 2, j);
						storeAvailableChoices(i - 1, j);
					}
				}
			}
		}

		//Diagonal Sets
		for (var i = 0; i < 5; i++) {
			if ($scope.gridStatus[i][i] == 1 && $scope.gridStatus[i+1][i + 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, i + 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, i - 1);
				} else {
					storeAvailableChoices(i + 2, i + 2);
					storeAvailableChoices(i - 1, i - 1);
				}
			}
		}

		//Immidiate Upper Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = i + 1;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Immidiate Lower Diagonal Sets
		for (var j = 0; j < 4; j++) {
			var i = j + 1;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1) {
				if (j == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (j == 3) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Upper Diagonal Set
		for (var i = 0; i < 3; i++) {
			var j = i + 2;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Lower Diagonal Set
		for (var j = 0; j < 3; j++) {
			var i = j + 2;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j + 1] == 1) {
				if (j == 0) {
					storeAvailableChoices(i + 2, j + 2);
				} else if (j == 2) {
					storeAvailableChoices(i - 1, j - 1);
				} else {
					storeAvailableChoices(i + 2, j + 2);
					storeAvailableChoices(i - 1, j - 1);
				}
			}
		}

		//Anti Diagonal Sets
		for (var i = 0; i < 5; i++) {
			var j = 5 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Upper Ant-Diagonal Sets
		for (var i = 0; i < 4; i++) {
			var j = 4 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 3) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Immidiate Lower Anti-Diagonal Sets
		for (var i = 1; i < 5; i++) {
			var j = 6 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1) {
				if (i == 1) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Upper Anti-Diagonal Set
		for (var i = 0; i < 3; i++) {
			var j = 3 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1) {
				if (i == 0) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 2) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}

		//Lower Anti-Diagonal Set
		for (var i = 2; i < 5; i++) {
			var j = 7 - i;
			if ($scope.gridStatus[i][j] == 1 && $scope.gridStatus[i+1][j - 1] == 1) {
				if (i == 2) {
					storeAvailableChoices(i + 2, j - 2);
				} else if (i == 4) {
					storeAvailableChoices(i - 1, j + 1);
				} else {
					storeAvailableChoices(i + 2, j - 2);
					storeAvailableChoices(i - 1, j + 1);
				}
			}
		}
		playRandomlyFromAvailableChoices();

	}

	function playRandom() {
		for (var i = 0; i < 6; i++) {
			for ( j = 0; j < 6; j++) {
				storeAvailableChoices(i, j);
			}
		}
		playRandomlyFromAvailableChoices();
	}

	function isWin(user) {
		//vertical sets
		for (var i = 0; i < 6; i++) {
			for (var j = 0; j < 3; j++) {
				if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i][j + 1] == user && $scope.gridStatus[i][j + 2] == user && $scope.gridStatus[i][j + 3] == user) {
					//	$scope.winner = user;
					applyWinCss($scope.grid[i][j], $scope.grid[i][j + 1], $scope.grid[i][j + 2], $scope.grid[i][j + 3]);
					return true;
				}
			}
		}

		//Horizontal Sets
		for (var i = 0; i < 3; i++) {
			for (var j = 0; j < 6; j++) {
				if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j] == user && $scope.gridStatus[i+2][j] == user && $scope.gridStatus[i+3][j] == user) {
					//	$scope.winner = user;
					applyWinCss($scope.grid[i][j], $scope.grid[i+1][j], $scope.grid[i+2][j], $scope.grid[i+3][j]);
					return true;
				}
			}
		}

		//Diagonal Sets
		for (var i = 0; i < 3; i++) {
			if ($scope.gridStatus[i][i] == user && $scope.gridStatus[i+1][i + 1] == user && $scope.gridStatus[i+2][i + 2] == user && $scope.gridStatus[i+3][i + 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j + 1], $scope.grid[i+2][j + 2], $scope.grid[i+3][j + 3]);
				return true;
			}
		}

		//Immidiate Upper Diagonal Sets
		for (var i = 0; i < 2; i++) {
			var j = i + 1;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j + 1] == user && $scope.gridStatus[i+2][j + 2] == user && $scope.gridStatus[i+3][j + 3] == user) {
				//$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j + 1], $scope.grid[i+2][j + 2], $scope.grid[i+3][j + 3]);
				return true;
			}
		}

		//Immidiate Lower Diagonal Sets
		for (var j = 0; j < 2; j++) {
			var i = j + 1;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j + 1] == user && $scope.gridStatus[i+2][j + 2] == user && $scope.gridStatus[i+3][j + 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j + 1], $scope.grid[i+2][j + 2], $scope.grid[i+3][j + 3]);

				return true;
			}
		}

		//Upper Diagonal Set
		for (var i = 0; i < 1; i++) {
			var j = i + 2;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j + 1] == user && $scope.gridStatus[i+2][j + 2] == user && $scope.gridStatus[i+3][j + 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j + 1], $scope.grid[i+2][j + 2], $scope.grid[i+3][j + 3]);

				return true;
			}
		}

		//Lower Diagonal Set
		for (var j = 0; j < 1; j++) {
			var i = j + 2;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j + 1] == user && $scope.gridStatus[i+2][j + 2] == user && $scope.gridStatus[i+3][j + 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j + 1], $scope.grid[i+2][j + 2], $scope.grid[i+3][j + 3]);

				return true;
			}
		}

		//Anti Diagonal Sets
		for (var i = 0; i < 3; i++) {
			var j = 5 - i;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j - 1] == user && $scope.gridStatus[i+2][j - 2] == user && $scope.gridStatus[i+3][j - 3] == user) {
				//		$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j - 1], $scope.grid[i+2][j - 2], $scope.grid[i+3][j - 3]);

				return true;
			}
		}

		//Immidiate Upper Ant-Diagonal Sets
		for (var i = 0; i < 2; i++) {
			var j = 4 - i;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j - 1] == user && $scope.gridStatus[i+2][j - 2] == user && $scope.gridStatus[i+3][j - 3] == user) {
				//		$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j - 1], $scope.grid[i+2][j - 2], $scope.grid[i+3][j - 3]);
				return true;
			}
		}

		//Immidiate Lower Anti-Diagonal Sets
		for (var i = 1; i < 3; i++) {
			var j = 6 - i;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j - 1] == user && $scope.gridStatus[i+2][j - 2] == user && $scope.gridStatus[i+3][j - 3] == user) {
				//		$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j - 1], $scope.grid[i+2][j - 2], $scope.grid[i+3][j - 3]);
				return true;
			}
		}

		//Upper Anti-Diagonal Set
		for (var i = 0; i < 1; i++) {
			var j = 3 - i;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j - 1] == user && $scope.gridStatus[i+2][j - 2] == user && $scope.gridStatus[i+3][j - 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j - 1], $scope.grid[i+2][j - 2], $scope.grid[i+3][j - 3]);
				return true;
			}
		}

		//Lower Anti-Diagonal Set
		for (var i = 2; i < 3; i++) {
			var j = 7 - i;
			if ($scope.gridStatus[i][j] == user && $scope.gridStatus[i+1][j - 1] == user && $scope.gridStatus[i+2][j - 2] == user && $scope.gridStatus[i+3][j - 3] == user) {
				//	$scope.winner = user;
				applyWinCss($scope.grid[i][j], $scope.grid[i+1][j - 1], $scope.grid[i+2][j - 2], $scope.grid[i+3][j - 3]);
				return true;
			}
		}
		return false;
	}


	$scope.flagx
	function indicateUserWin() {
		if ($scope.flagx == 1) {
			$scope.gridclass[$scope.a] = ' ' + $scope.winUserCSS;
			$scope.gridclass[$scope.b] = ' ' + $scope.winUserCSS;
			$scope.gridclass[$scope.c] = ' ' + $scope.winUserCSS;
			$scope.gridclass[$scope.d] = ' ' + $scope.winUserCSS;
			$scope.flagx = 2;
		} else {
			$scope.gridclass[$scope.a] = ' ' + $scope.winUserCSS1;
			$scope.gridclass[$scope.b] = ' ' + $scope.winUserCSS1;
			$scope.gridclass[$scope.c] = ' ' + $scope.winUserCSS1;
			$scope.gridclass[$scope.d] = ' ' + $scope.winUserCSS1;
			$scope.flagx = 1;
		}
	}

	function indicateComputerWin() {
		if ($scope.flagx == 1) {
			$scope.gridclass[$scope.a] = ' ' + $scope.winComputerCSS;
			$scope.gridclass[$scope.b] = ' ' + $scope.winComputerCSS;
			$scope.gridclass[$scope.c] = ' ' + $scope.winComputerCSS;
			$scope.gridclass[$scope.d] = ' ' + $scope.winComputerCSS;
			$scope.flagx = 2;
		} else {
			$scope.gridclass[$scope.a] = ' ' + $scope.winComputerCSS1;
			$scope.gridclass[$scope.b] = ' ' + $scope.winComputerCSS1;
			$scope.gridclass[$scope.c] = ' ' + $scope.winComputerCSS1;
			$scope.gridclass[$scope.d] = ' ' + $scope.winComputerCSS1;
			$scope.flagx = 1;
		}
	}

	function applyWinCss(a, b, c, d) {
		$scope.a = a;
		$scope.b = b;
		$scope.c = c;
		$scope.d = d;
	}

});
